## rehex 0.62.0

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2024 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

LUA          ?= lua
WX_CONFIG    ?= wx-config
BOTAN_PKG    ?= botan-2
CAPSTONE_PKG ?= capstone
JANSSON_PKG  ?= jansson
LUA_PKG      ?= $(shell pkg-config --exists lua5.3 && echo lua5.3 || echo lua)
CXXSTD       ?= -std=c++11

EXE ?= rehex
EMBED_EXE ?= ./tools/embed
TEST_EXE ?= ./tests/all-tests
GTKCONFIG_EXE ?= ./tools/gtk-config
HELP_TARGET ?= help/rehex.htb

DEFAULT_EXE_TARGET  ?= $(EXE)
DEFAULT_TEST_TARGET ?= $(TEST_EXE)

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $$(shell $(1); echo $$$$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

# Check if we are building target(s) that don't need to compile anything and
# skip fetching compiler flags from wx-config/pkg-config/etc if so, this avoids
# having to have our dependencies on build hosts that are going to use a chroot
# or other container for doing the actual build.

NONCOMPILE_TARGETS=clean distclean dist

need_compiler_flags ?= 1
ifneq ($(MAKECMDGOALS),)
	ifeq ($(filter-out $(NONCOMPILE_TARGETS),$(MAKECMDGOALS)),)
		need_compiler_flags=0
	endif
endif

ifeq ($(BUILD_HELP),)
	BUILD_HELP=1
endif

ifeq ($(BUILD_HELP),0)
	HELP_TARGET :=
else
	HELP_CFLAGS := -DBUILD_HELP
	HELP_LIBS := html
endif

ifeq ($(need_compiler_flags),1)
	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv net $(HELP_LIBS))
	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv net $(HELP_LIBS))
	
	BOTAN_CFLAGS ?= $(call shell-or-die,pkg-config $(BOTAN_PKG) --cflags)
	BOTAN_LIBS   ?= $(call shell-or-die,pkg-config $(BOTAN_PKG) --libs)
	
	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
	
	JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
	JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
	
	LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
	LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
	
	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
endif

BASE_CFLAGS := -Wall

DEBUG_CFLAGS   := -ggdb
RELEASE_CFLAGS := -g -O2 -DNDEBUG
PROFILE_CFLAGS := $(RELEASE_CFLAGS) -DREHEX_PROFILE

ifeq ($(BUILD_TYPE),)
	BUILD_TYPE := release
endif

ifeq ($(BUILD_TYPE),release)
	BASE_CFLAGS += $(RELEASE_CFLAGS)
else
	ifeq ($(BUILD_TYPE),debug)
		BASE_CFLAGS += $(DEBUG_CFLAGS)
	else
		ifeq ($(BUILD_TYPE),profile)
			BASE_CFLAGS += $(PROFILE_CFLAGS)
		else
			X := $(error unknown BUILD_TYPE '$(BUILD_TYPE)' (should be release, debug or profile))
		endif
	endif
endif

CFLAGS          := $(BASE_CFLAGS) -std=c99   -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/                       -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
CXXFLAGS_NO_GTK := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
CXXFLAGS        := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)

uname_S := $(shell uname -s 2>/dev/null)
ifeq ($(uname_S),FreeBSD)
	LDLIBS += -liconv
endif
ifeq ($(uname_S),OpenBSD)
	LDLIBS += -liconv
endif

LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(BOTAN_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)

# Define this for releases
VERSION := 0.62.0

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	# Check if we are actually in a git checkout before trying to get the
	# commit hash with `git log`, else we blow up in a git-archive export.
	
	ifneq ($(wildcard .git/*),)
		GIT_COMMIT_SHA ?= $(call shell-or-die,git log -1 --format="%H")
	else
		GIT_COMMIT_SHA ?= UNKNOWN
	endif
	
	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
	
	VERSION      := 513172506f17f58a4a56045873bcc043eede2a98
	LONG_VERSION := Snapshot 513172506f17f58a4a56045873bcc043eede2a98
endif

DEPDIR := .d
DEPPRE = @mkdir -p "$(dir $(DEPDIR)/$@.Td)"
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

WXLUA_BINDINGS := wxLua/bindings/.done

.PHONY: all
all: $(EXE)

# Stop Make from deleting intermediate files at-will. Some intermediates (e.g. resources) are used
# by multiple targets (all and test) and so they should persist. Others are generated as a
# side-effect of another target (wxLua bindings) so Make cannot properly track how to build them
# when it needs to recreate them later.
.SECONDARY:

.PHONY: check
check: $(TEST_EXE)
	$(TEST_EXE)
	
	for p in $(PLUGINS); \
	do \
		$(MAKE) -C plugins/$${p} LUA=$(LUA) check || exit $$?; \
	done

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/diff_fold16.c res/diff_fold16.h \
	      res/diff_fold24.c res/diff_fold24.h \
	      res/diff_fold32.c res/diff_fold32.h \
	      res/diff_fold48.c res/diff_fold48.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h   res/license.done \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h \
	      res/shortcut48.c  res/shortcut48.h \
	      res/spinner24.c   res/spinner24.h
	
	rm -f $(filter-out %.$(BUILD_TYPE).o,$(APP_OBJS))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.debug.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.release.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.profile.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(EXE)
	
	rm -f $(filter-out %.$(BUILD_TYPE).o,$(TEST_OBJS))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.debug.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.release.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.profile.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(TEST_EXE)
	
	rm -f $(EMBED_EXE)
	rm -f $(GTKCONFIG_EXE)
	
	grep -r "generated by genwxbind.lua" wxLua/ --exclude=genwxbind.lua | cut -d: -f1 | sort | uniq | xargs -r rm
	rm -f $(WXLUA_BINDINGS)
	
	rm -f src/lua-bindings/rehex_bind.done src/lua-bindings/rehex_bind.cpp src/lua-bindings/rehex_bind.h
	rm -f src/lua-plugin-preload.done src/lua-plugin-preload.c src/lua-plugin-preload.h

.PHONY: distclean
distclean: clean

WXLUA_OBJS := \
	wxLua/modules/wxlua/bit.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/lbitlib.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlbind.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlcallb.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxllua.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlobject.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlstate.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlua_bind.$(BUILD_TYPE).o

WXBIND_OBJS := \
	wxLua/modules/wxbind/src/wxadv_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxadv_wxladv.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxaui_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_base.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_config.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_data.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_datetime.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_file.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_appframe.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_clipdrag.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_controls.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_core.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_defsutils.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_dialogs.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_event.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_gdi.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_geometry.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_graphics.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_help.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_image.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_mdi.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_menutool.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_picker.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_print.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_sizer.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_windows.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_wxlcore.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxpropgrid_bind.$(BUILD_TYPE).o

WXFREECHART_OBJS := \
	wxFreeChart/src/areadraw.$(BUILD_TYPE).o \
	wxFreeChart/src/art.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/axis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/categoryaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/compdateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/dateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/juliandateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/labelaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/logarithmicnumberaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/numberaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axisplot.$(BUILD_TYPE).o \
	wxFreeChart/src/bars/barplot.$(BUILD_TYPE).o \
	wxFreeChart/src/bars/barrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categorydataset.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categoryrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categorysimpledataset.$(BUILD_TYPE).o \
	wxFreeChart/src/chart.$(BUILD_TYPE).o \
	wxFreeChart/src/chartpanel.$(BUILD_TYPE).o \
	wxFreeChart/src/chartsplitpanel.$(BUILD_TYPE).o \
	wxFreeChart/src/colorscheme.$(BUILD_TYPE).o \
	wxFreeChart/src/crosshair.$(BUILD_TYPE).o \
	wxFreeChart/src/dataset.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttdataset.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttplot.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttsimpledataset.$(BUILD_TYPE).o \
	wxFreeChart/src/legend.$(BUILD_TYPE).o \
	wxFreeChart/src/marker.$(BUILD_TYPE).o \
	wxFreeChart/src/multiplot.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/movingaverage.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlcbarrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlccandlestickrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlcdataset.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlcplot.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlcrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/ohlc/ohlcsimpledataset.$(BUILD_TYPE).o \
	wxFreeChart/src/pie/pieplot.$(BUILD_TYPE).o \
	wxFreeChart/src/plot.$(BUILD_TYPE).o \
	wxFreeChart/src/renderer.$(BUILD_TYPE).o \

=== help/Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2022-2024 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

HHC ?= "C:\Program Files (x86)\HTML Help Workshop\hhc.exe"
PERL ?= perl

PAGES := \
	bitedit \
	bitmap \
	bt \
	bt-funcs \
	bt-preprocessor \
	bt-syntax \
	bt-types \
	checksum \
	comments \
	diff \
	highlights \
	index \
	plugins \
	types \
	value-colour-map \
	virt-mapping

.PHONY: all
all:
	@echo "Usage: make rehex.htb OR rehex.chm OR online-help" 1>&2
	@false

# Don't leave empty/incomplete pages if rendering fails
.DELETE_ON_ERROR:

.PHONY: clean
clean:
	rm -rf chm/output/
	rm -rf wx/output/
	rm -rf online/output/

CHM_PAGE_EXT := htm

CHM_TARGETS := \
	$(addsuffix .$(CHM_PAGE_EXT),$(addprefix chm/output/,$(PAGES))) \
	chm/output/rehex.hhc \
	chm/output/rehex.hhk

rehex.chm: $(CHM_TARGETS)
	cp content/* chm/content/* chm/output/
	# hhc.exe returns 0 on failure and 1 on success... good job Microsoft.
	# https://stackoverflow.com/a/39040033
	! $(HHC) chm/output/rehex.hhp
	cp chm/output/rehex.chm $@

chm/output/rehex.%: chm/templates/%.tt contents.txt
	@mkdir -p chm/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include chm/templates --dep-file .d/$@.d --dep-target $@ $* > $@

chm/output/%.$(CHM_PAGE_EXT): pages/%.tt
	@mkdir -p chm/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --define page_ext=$(CHM_PAGE_EXT) --include chm/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

WX_PAGE_EXT := html

WX_TARGETS := \
	$(addsuffix .$(WX_PAGE_EXT),$(addprefix wx/output/,$(PAGES))) \
	wx/output/rehex.hhc \
	wx/output/rehex.hhk

rehex.htb: $(WX_TARGETS)
	cp content/* wx/content/* wx/output/
	zip -X -rj rehex.htb wx/output/*

wx/output/rehex.%: wx/templates/%.tt contents.txt
	@mkdir -p wx/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include wx/templates --dep-file .d/$@.d --dep-target $@ $* > $@

wx/output/%.$(WX_PAGE_EXT): pages/%.tt
	@mkdir -p wx/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --define page_ext=$(WX_PAGE_EXT) --include wx/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

ONLINE_PAGE_EXT := html

ONLINE_TARGETS := \
	$(addsuffix .$(ONLINE_PAGE_EXT),$(addprefix online/output/,$(PAGES)))

.PHONY: online-help
online-help: $(ONLINE_TARGETS)
	cp content/* online/content/* online/output/

online/output/%.$(ONLINE_PAGE_EXT): pages/%.tt contents.txt
	@mkdir -p online/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --define page_ext=$(ONLINE_PAGE_EXT) --include online/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

include $(shell test -d .d/ && find .d/ -name '*.d' -type f)

=== plugins/binary-template/Makefile ===
# Binary Template plugin for REHex
# Copyright (C) 2021-2023 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

INSTALL_FILES := \
	executor.lua \
	executor/arrayindexvalue.lua \
	executor/arrayvalue.lua \
	executor/filearrayvalue.lua \
	executor/filevalue.lua \
	executor/immediatevalue.lua \
	executor/plainvalue.lua \
	executor/structvalue.lua \
	executor/typemapper.lua \
	executor/util.lua \
	executor/varallocator.lua \
	parser.lua \
	plugin.lua \
	preprocessor.lua \
	lulpeg/lulpeg.lua \
	templates/riff.bt

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
libdir      ?= $(exec_prefix)/lib

LUA ?= lua

PLUGIN_NAME := binary-template
PLUGINS_INST_DIR ?= $(DESTDIR)$(libdir)/rehex

ifeq ($(BUSTED),)
	# LuaRocks under MinGW doesn't install busted under a bin/ directory - it sticks it
	# elsewhere and puts a .bat that runs it under the right Lua environment for Reasons.
	
	BUSTED := $(shell busted --version > /dev/null 2>&1 && echo busted --lua=$(LUA))
	ifeq ($(BUSTED),)
		BUSTED := $(shell busted.bat --version > /dev/null 2>&1 && echo busted.bat --lua=$(LUA))
	endif
	
	ifeq ($(BUSTED),)
		X := $(error Neither busted or busted.bat found in PATH)
	endif
endif

.PHONY: all
all:

.PHONY: check
check:
	$(BUSTED) .

.PHONY: install
install:
	for f in $(INSTALL_FILES); \
	do \
		mkdir -p $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/`dirname $${f}`; \
		install -m 0644 $${f} $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/$${f}; \
	done

.PHONY: uninstall
uninstall:
	rm -f $(addprefix $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/,$(INSTALL_FILES))
	
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/templates/
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/lulpeg/
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/

=== plugins/exe/Makefile ===
# PE EXE/DLL parsing plugin for REHex
# Copyright (C) 2021 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

INSTALL_FILES := \
	bitops52.lua \
	class.lua \
	document_stream.lua \
	enum.lua \
	kaitaistruct.lua \
	microsoft_pe.lua \
	plugin.lua \
	string_decode.lua \
	string_stream.lua \
	utils.lua

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
libdir      ?= $(exec_prefix)/lib

PLUGIN_NAME := exe
PLUGINS_INST_DIR ?= $(DESTDIR)$(libdir)/rehex

.PHONY: all
all:

.PHONY: check
check:

.PHONY: install
install:
	for f in $(INSTALL_FILES); \
	do \
		mkdir -p $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/`dirname $${f}`; \
		install -m 0644 $${f} $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/$${f}; \
	done

.PHONY: uninstall
uninstall:
	rm -f $(addprefix $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/,$(INSTALL_FILES))
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/

=== debian/changelog ===
rehex (0.62.0-0~ubuntu2004) focal; urgency=low

  * Add bit array data type (#167).

  * Allow selecting and setting comments/highlights/types on
    bit-sized/aligned quantities, not just byte-aligned (#155).

  * Allow defining arbitrary integer types, up to 64 bits wide (#215).

  * Allow colouring data by byte value (#223).

  * Allow changing/defining custom highlight colours and assigning
    labels to them (#227).

  * Use dimmer highlight colours for dark colour schemes (#227).

  * Save highlight colours/labels per-file (#60).

  * Allow changing keyboard shortcuts (#226).

  * Add Shift+Enter shortcut for "OK" in the comment dialog (#226).

  * Display offset in both decimal and hexadecimal in status bar (#228).

  * Fix handling of relative paths specified on the command line when
    opening in an existing instance (#237).

  * Allow navigating hex data by nibbles rather than bytes (#58).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 20 Jul 2024 18:40:00 +0100

rehex (0.61.1-0~ubuntu2004) focal; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 13 Mar 2024 18:13:45 +0000

rehex (0.61.0-0~ubuntu2004) focal; urgency=low

  * Permit trailing commas in template enum definitions (#216).

  * Add overwrite/insert toggle to "Fill range" dialog (#213).

  * Add copy/export context menu commands to strings tool (#210).

  * Fix temporary hang in strings tool when processing large files (#217).

  * Fix settings not being saved during application exit.

  * Batch comments panel updates to improve responsiveness (#205).

  * Add search field to comments panel (#204).

  * Add bit editor tool.

  * Add checksum tool (#219).

  * Add options to search for floating point values.

  * Don't reload files modified externally when requested not to.

  * Start search when Enter is pressed in search dialog input field, or search
    backwards when Shift+Enter is pressed.

  * Add "Reload automatically" toggle to "File" menu to automatically reload
    the file when modified externally (and not in the editor) (#222).

  * Preserve scroll position when reloading file.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 14 Feb 2024 21:27:50 +0000

rehex (0.60.1-0~ubuntu2004) focal; urgency=low

  * Install missing parts of binary template plugin.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 20:41:31 +0100

rehex (0.60.0-0~ubuntu2004) focal; urgency=low

  * Add data histogram tool (#140).

  * Use virtual offsets in "Select range" dialog.

  * Don't re-open files to save when there are no changes (#193).

  * Remember recently selected templates (#183).

  * Fix crash when running rehex for the first time on some systems (#194).

  * Correctly draw insert cursor over highlighted data and at the end of the
    file (#196).

  * Fix true/false not being usable inside template functions/structs (#197).

  * Expose current array index as ArrayIndex when expanding arrays of structs
    in templates (#191).

  * Implement lexical variable scoping in templates and allow functions to
    access global variables defined above them (#190).

  * Add <charset = "XXX"> syntax to templates (#184).

  * Add character set option to text search (#182, #200).

  * Add "Delete comment and children" context menu command to delete a comment
    and any comments encapsulated by it (#198).

  * Add "Apply template from cursor" option to binary template tool.

  * Fix cases where the strings tool would appear to run forever with an empty
    file.

  * Remove strings from the strings panel when they are deleted from the file.

  * Add new ReadString(), SPrintf(), SetComment(), StringLengthBytes(),
    ArrayPush(), ArrayPop() and OffsetOf() template function.

  * Fix repeated execution of the same switch() block in a template (#202).

  * Monitor for open files being externally modified and allow reloading (#124).

  * Add 'private' variables to template language.

  * Fix template format strings that expand to further format tokens.

  * Fix template error when converting a float to an int.

  * Improve performance when large numbers of comments are defined.

  * Open original file when passed a rehex-meta file on the command line (#207).

  * Add IBM codepage 866 and Windows-1251 (#208).

  * Fix crash when attempting to open a directory/bundle on macOS.
 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 19:50:45 +0100

rehex (0.5.4-0~ubuntu2004) focal; urgency=low

  * Allow passing arguments to structs created via ArrayResize() and
    ArrayExtend() template functions.

  * Fix parsing of whitespace in template array dereference (#175).

  * Display offsets in comments panel (#165).

  * Don't show expand arrows next to comments without children in comments
    panel on Windows/macOS.

  * Improve performance of templates that declare many (thousands+) of
    variables in the file.

  * Add Error() function for templates (#186).

  * Fix crash when attempting to use string as a file variable in
    templates (#185).

  * [Pavel Martens] Add plugin for annotating pcap files.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 23 Oct 2022 22:52:12 +0100

rehex (0.5.3-0~ubuntu2004) focal; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.



=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 debhelper (>= 9),
 libbotan-2-dev,
 libcapstone-dev,
 libgtk-3-dev,
 libjansson-dev,
 libwxgtk3.0-gtk3-dev,
 liblua5.3-dev,
 libtemplate-perl,
 libunistring-dev,
 lua-busted,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.0-headers,
 zip,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libbotan-2-12,
 libcapstone3,
 libjansson4,
 libwxgtk3.0-gtk3-0v5,
 liblua5.3-0,
 libunistring2,
 zlib1g
Description: Reverse Engineers' Hex Editor

## rehex 0.63.2

=== Makefile ===
--- 
+++ 
@@ -14,13 +14,20 @@
 # this program; if not, write to the Free Software Foundation, Inc., 51
 # Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
+# Returns the first of $(1) or $(2) which is defined in the pkg-config
+# database, or errors if neither are.
+pkg-select-ab = $\
+	$(if $(filter yes,$(shell pkg-config --exists $(1) && echo yes)),$(1),$\
+		$(if $(filter yes,$(shell pkg-config --exists $(2) && echo yes)),$(2),$\
+			$(error Could not find $(1) or $(2) using pkg-config)))
+
 LUA          ?= lua
 WX_CONFIG    ?= wx-config
-BOTAN_PKG    ?= botan-2
+BOTAN_PKG    ?= $(call pkg-select-ab,botan-3,botan-2)
 CAPSTONE_PKG ?= capstone
 JANSSON_PKG  ?= jansson
-LUA_PKG      ?= $(shell pkg-config --exists lua5.3 && echo lua5.3 || echo lua)
-CXXSTD       ?= -std=c++11
+LUA_PKG      ?= $(call pkg-select-ab,lua5.3,lua)
+JQ           ?= jq
 
 EXE ?= rehex
 EMBED_EXE ?= ./tools/embed
@@ -82,6 +89,12 @@
 	
 	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
 	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
+	
+	ifeq ($(BOTAN_PKG),botan-3)
+		CXXSTD ?= -std=c++20
+	else
+		CXXSTD ?= -std=c++11
+	endif
 endif
 
 BASE_CFLAGS := -Wall
@@ -108,9 +121,9 @@
 	endif
 endif
 
-CFLAGS          := $(BASE_CFLAGS) -std=c99   -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/                       -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
-CXXFLAGS_NO_GTK := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
-CXXFLAGS        := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
+CFLAGS          := $(BASE_CFLAGS) -std=c99   -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/                       $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
+CXXFLAGS_NO_GTK := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override  $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
+CXXFLAGS        := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override  $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
 
 uname_S := $(shell uname -s 2>/dev/null)
 ifeq ($(uname_S),FreeBSD)
@@ -123,7 +136,9 @@
 LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(BOTAN_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)
 
 # Define this for releases
-VERSION := 0.62.0
+# NOTE: This *MUST* be of the form a.b.c where each component is an integer to fit the format of
+# macOS version numbers and Windows version info resources.
+VERSION := 0.63.2
 
 ifdef VERSION
 	LONG_VERSION := Version $(VERSION)
@@ -139,8 +154,8 @@
 	
 	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
 	
-	VERSION      := 513172506f17f58a4a56045873bcc043eede2a98
-	LONG_VERSION := Snapshot 513172506f17f58a4a56045873bcc043eede2a98
+	VERSION      := 8ea16a9885236f50554b619002807a7c941630a1
+	LONG_VERSION := Snapshot 8ea16a9885236f50554b619002807a7c941630a1
 endif
 
 DEPDIR := .d
@@ -178,6 +193,10 @@
 	      res/diff_fold24.c res/diff_fold24.h \
 	      res/diff_fold32.c res/diff_fold32.h \
 	      res/diff_fold48.c res/diff_fold48.h \
+	      res/dock_bottom.c res/dock_bottom.h \
+	      res/dock_left.c   res/dock_left.h \
+	      res/dock_right.c  res/dock_right.h \
+	      res/dock_top.c    res/dock_top.h \
 	      res/icon16.c    res/icon16.h \
 	      res/icon32.c    res/icon32.h \
 	      res/icon48.c    res/icon48.h \
@@ -283,17 +302,3 @@
 	wxFreeChart/src/gantt/ganttdataset.$(BUILD_TYPE).o \
 	wxFreeChart/src/gantt/ganttplot.$(BUILD_TYPE).o \
 	wxFreeChart/src/gantt/ganttrenderer.$(BUILD_TYPE).o \
-	wxFreeChart/src/gantt/ganttsimpledataset.$(BUILD_TYPE).o \
-	wxFreeChart/src/legend.$(BUILD_TYPE).o \
-	wxFreeChart/src/marker.$(BUILD_TYPE).o \
-	wxFreeChart/src/multiplot.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/movingaverage.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlcbarrenderer.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlccandlestickrenderer.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlcdataset.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlcplot.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlcrenderer.$(BUILD_TYPE).o \
-	wxFreeChart/src/ohlc/ohlcsimpledataset.$(BUILD_TYPE).o \
-	wxFreeChart/src/pie/pieplot.$(BUILD_TYPE).o \
-	wxFreeChart/src/plot.$(BUILD_TYPE).o \
-	wxFreeChart/src/renderer.$(BUILD_TYPE).o \

=== plugins/binary-template/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Binary Template plugin for REHex
-# Copyright (C) 2021-2023 Daniel Collins <solemnwarning@solemnwarning.net>
+# Copyright (C) 2021-2025 Daniel Collins <solemnwarning@solemnwarning.net>
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 as published by
@@ -30,6 +30,7 @@
 	plugin.lua \
 	preprocessor.lua \
 	lulpeg/lulpeg.lua \
+	stable_sort.lua \
 	templates/riff.bt
 
 prefix      ?= /usr/local

=== debian/changelog ===
rehex (0.63.2-0~debian11) bullseye; urgency=low

  * Add missing file required for binary template support.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:57:02 +0100

rehex (0.63.1-0~debian11) bullseye; urgency=low

  * Improve performance of templates that declare large numbers of file
    variables.

  * Fix selecting the byte range encapsulated by a comment (#255).

  * Add "Jump to end" command to comments panel context menu (#254).

  * Improve rendering performance and UI responsiveness, particularly
    when a large number of colours are in use (#257).

  * Fix searching within a range.

  * Default to selection when a range is selected prior to opening
    search dialog (#256).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:22:02 +0100

rehex (0.63.0-0~debian11) bullseye; urgency=low

  * Add non-modal "Jump to offset" dialog option (#242).

  * Add "Repeat last 'Jump to offset'" command (#242).

  * Add "Visual Scrollbar" for high-level overview of file contents.

  * Add "Data visualisation" tool for overfiew of file/selection
    contents (#230).

  * Add metadata import/export commands (#248).

  * Fix crash when <charset = "US-ASCII"> is specified for a file variable
    in a template (#246).

  * Add highlight functions to scripting API and template language (#247).

  * Fix memory leaks in bitmap preview tool and metadata serialisation.

  * Suspend scanning for strings when the strings tool is hidden.

  * Fix the continue/reset buttons in the strings tool not working
    correctly.

  * Fix horizontal scroll position being set out-of-range when the window is
    resized in some situations.

  * Fix bitmap preview tool not following cursor correctly (#244).

  * Allow detaching tool panels to floating windows or docking them to any
    side of the main window (#229).

  * Reduce unnecessary padding in decimal offsets (#235).

  * Fix range selection input for checksum/histogram on macOS.

  * Fix selection being prematurely initiated when the mouse is clicked
    over file data.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Jun 2025 11:47:36 +0100

rehex (0.62.0-0~debian11) bullseye; urgency=low

  * Add bit array data type (#167).

  * Allow selecting and setting comments/highlights/types on
    bit-sized/aligned quantities, not just byte-aligned (#155).

  * Allow defining arbitrary integer types, up to 64 bits wide (#215).

  * Allow colouring data by byte value (#223).

  * Allow changing/defining custom highlight colours and assigning
    labels to them (#227).

  * Use dimmer highlight colours for dark colour schemes (#227).

  * Save highlight colours/labels per-file (#60).

  * Allow changing keyboard shortcuts (#226).

  * Add Shift+Enter shortcut for "OK" in the comment dialog (#226).

  * Display offset in both decimal and hexadecimal in status bar (#228).

  * Fix handling of relative paths specified on the command line when
    opening in an existing instance (#237).

  * Allow navigating hex data by nibbles rather than bytes (#58).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 20 Jul 2024 18:39:59 +0100

rehex (0.61.1-0~debian11) bullseye; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 13 Mar 2024 18:13:44 +0000

rehex (0.61.0-0~debian11) bullseye; urgency=low

  * Permit trailing commas in template enum definitions (#216).

  * Add overwrite/insert toggle to "Fill range" dialog (#213).

  * Add copy/export context menu commands to strings tool (#210).

  * Fix temporary hang in strings tool when processing large files (#217).

  * Fix settings not being saved during application exit.

  * Batch comments panel updates to improve responsiveness (#205).

  * Add search field to comments panel (#204).

  * Add bit editor tool.

  * Add checksum tool (#219).

  * Add options to search for floating point values.

  * Don't reload files modified externally when requested not to.

  * Start search when Enter is pressed in search dialog input field, or search
    backwards when Shift+Enter is pressed.

  * Add "Reload automatically" toggle to "File" menu to automatically reload
    the file when modified externally (and not in the editor) (#222).

  * Preserve scroll position when reloading file.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 14 Feb 2024 21:27:50 +0000

rehex (0.60.1-0~debian11) bullseye; urgency=low

  * Install missing parts of binary template plugin.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 20:41:31 +0100

rehex (0.60.0-0~debian11) bullseye; urgency=low

  * Add data histogram tool (#140).

  * Use virtual offsets in "Select range" dialog.

  * Don't re-open files to save when there are no changes (#193).

  * Remember recently selected templates (#183).

  * Fix crash when running rehex for the first time on some systems (#194).

  * Correctly draw insert cursor over highlighted data and at the end of the
    file (#196).

  * Fix true/false not being usable inside template functions/structs (#197).

  * Expose current array index as ArrayIndex when expanding arrays of structs
    in templates (#191).

  * Implement lexical variable scoping in templates and allow functions to
    access global variables defined above them (#190).

  * Add <charset = "XXX"> syntax to templates (#184).

  * Add character set option to text search (#182, #200).

  * Add "Delete comment and children" context menu command to delete a comment
    and any comments encapsulated by it (#198).

  * Add "Apply template from cursor" option to binary template tool.

  * Fix cases where the strings tool would appear to run forever with an empty
    file.

  * Remove strings from the strings panel when they are deleted from the file.

  * Add new ReadString(), SPrintf(), SetComment(), StringLengthBytes(),


=== debian/control ===
--- 
+++ 
@@ -7,10 +7,10 @@
  libcapstone-dev,
  libgtk-3-dev,
  libjansson-dev,
- libwxgtk3.0-gtk3-dev,
  liblua5.3-dev,
  libtemplate-perl,
  libunistring-dev,
+ libwxgtk3.0-gtk3-dev,
  lua-busted,
  lua5.3,
  pkg-config,
@@ -28,11 +28,11 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- libbotan-2-12,
- libcapstone3,
+ libbotan-2-17,
+ libcapstone4,
  libjansson4,
- libwxgtk3.0-gtk3-0v5,
  liblua5.3-0,
  libunistring2,
+ libwxgtk3.0-gtk3-0v5,
  zlib1g
 Description: Reverse Engineers' Hex Editor

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export prefix := /usr

# Snapshot builds are performed using source packages generated by git-buildpackage, which lack
# the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
# must then pull back out and stick in the environment for the Makefile.
#
# This hack is better or worse than maintaining upstream tar in the Git repo and import-orig'ing
# the result of 'make dist' before kicking off the snapshot build, depending on your point of view.

GIT_COMMIT_SHA = $(shell dpkg-parsechangelog --show-field Version | grep + | cut -d+ -f2 | cut -d- -f1)
ifneq ($(GIT_COMMIT_SHA),)
	export GIT_COMMIT_SHA
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_J_FLAG = -j$(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a -e /dev/stdout make $(MAKE_J_FLAG) LUA=lua5.3 check

## rehex 0.63.3

=== Makefile ===
--- 
+++ 
@@ -138,7 +138,7 @@
 # Define this for releases
 # NOTE: This *MUST* be of the form a.b.c where each component is an integer to fit the format of
 # macOS version numbers and Windows version info resources.
-VERSION := 0.63.2
+VERSION := 0.63.3
 
 ifdef VERSION
 	LONG_VERSION := Version $(VERSION)
@@ -154,8 +154,8 @@
 	
 	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
 	
-	VERSION      := 8ea16a9885236f50554b619002807a7c941630a1
-	LONG_VERSION := Snapshot 8ea16a9885236f50554b619002807a7c941630a1
+	VERSION      := e317aae0272534a4631143819631a5cf7c1ee87d
+	LONG_VERSION := Snapshot e317aae0272534a4631143819631a5cf7c1ee87d
 endif
 
 DEPDIR := .d

=== debian/changelog ===
rehex (0.63.3-0~debian13) trixie; urgency=low

  * Add option to change bitmap visualisation image background to a
    chosen colour (#258).

  * Copy and save full-size image with alpha channel from bitmap
    visualisation instead of the preview image.

  * Add light icons for use with dark themes to bitmap visualisation and
    histogram views (#262).

  * Add search history to text search dialog (#260).

  * Work around crash with large bitmap previews on Linux (#263).

  * Improve performance of bitmap visualisation.

  * Added missing MOS6502 and Motorola 6800/68k disassembly support for
    x86 Windows (#264).

  * Added RISC-V and WASM disassembly support (where supported by host
    Capstone library).

  * Implement tool panel detaching/docking under Wayland (#252).

  * Update detached tool window title when tab is changed.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 08 Sep 2025 21:47:28 +0100

rehex (0.63.2-0~debian13) trixie; urgency=low

  * Add missing file required for binary template support.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 26 Aug 2025 22:09:29 +0100

rehex (0.63.1-0~debian12) bookworm; urgency=low

  * Improve performance of templates that declare large numbers of file
    variables.

  * Fix selecting the byte range encapsulated by a comment (#255).

  * Add "Jump to end" command to comments panel context menu (#254).

  * Improve rendering performance and UI responsiveness, particularly
    when a large number of colours are in use (#257).

  * Fix searching within a range.

  * Default to selection when a range is selected prior to opening
    search dialog (#256).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:22:01 +0100

rehex (0.63.0-0~debian12) bookworm; urgency=low

  * Add non-modal "Jump to offset" dialog option (#242).

  * Add "Repeat last 'Jump to offset'" command (#242).

  * Add "Visual Scrollbar" for high-level overview of file contents.

  * Add "Data visualisation" tool for overfiew of file/selection
    contents (#230).

  * Add metadata import/export commands (#248).

  * Fix crash when <charset = "US-ASCII"> is specified for a file variable
    in a template (#246).

  * Add highlight functions to scripting API and template language (#247).

  * Fix memory leaks in bitmap preview tool and metadata serialisation.

  * Suspend scanning for strings when the strings tool is hidden.

  * Fix the continue/reset buttons in the strings tool not working
    correctly.

  * Fix horizontal scroll position being set out-of-range when the window is
    resized in some situations.

  * Fix bitmap preview tool not following cursor correctly (#244).

  * Allow detaching tool panels to floating windows or docking them to any
    side of the main window (#229).

  * Reduce unnecessary padding in decimal offsets (#235).

  * Fix range selection input for checksum/histogram on macOS.

  * Fix selection being prematurely initiated when the mouse is clicked
    over file data.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Jun 2025 11:47:36 +0100

rehex (0.62.0-0~debian12) bookworm; urgency=low

  * Add bit array data type (#167).

  * Allow selecting and setting comments/highlights/types on
    bit-sized/aligned quantities, not just byte-aligned (#155).

  * Allow defining arbitrary integer types, up to 64 bits wide (#215).

  * Allow colouring data by byte value (#223).

  * Allow changing/defining custom highlight colours and assigning
    labels to them (#227).

  * Use dimmer highlight colours for dark colour schemes (#227).

  * Save highlight colours/labels per-file (#60).

  * Allow changing keyboard shortcuts (#226).

  * Add Shift+Enter shortcut for "OK" in the comment dialog (#226).

  * Display offset in both decimal and hexadecimal in status bar (#228).

  * Fix handling of relative paths specified on the command line when
    opening in an existing instance (#237).

  * Allow navigating hex data by nibbles rather than bytes (#58).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 20 Jul 2024 18:39:59 +0100

rehex (0.61.1-0~debian12) bookworm; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 13 Mar 2024 18:13:44 +0000

rehex (0.61.0-0~debian12) bookworm; urgency=low

  * Permit trailing commas in template enum definitions (#216).

  * Add overwrite/insert toggle to "Fill range" dialog (#213).

  * Add copy/export context menu commands to strings tool (#210).

  * Fix temporary hang in strings tool when processing large files (#217).

  * Fix settings not being saved during application exit.

  * Batch comments panel updates to improve responsiveness (#205).

  * Add search field to comments panel (#204).

  * Add bit editor tool.

  * Add checksum tool (#219).

  * Add options to search for floating point values.

  * Don't reload files modified externally when requested not to.

  * Start search when Enter is pressed in search dialog input field, or search
    backwards when Shift+Enter is pressed.

  * Add "Reload automatically" toggle to "File" menu to automatically reload
    the file when modified externally (and not in the editor) (#222).

  * Preserve scroll position when reloading file.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 14 Feb 2024 21:27:50 +0000

rehex (0.60.1-0~debian12) bookworm; urgency=low

  * Install missing parts of binary template plugin.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 20:41:22 +0100

rehex (0.60.0-0~debian12) bookworm; urgency=low

  * Add data histogram tool (#140).

  * Use virtual offsets in "Select range" dialog.

  * Don't re-open files to save when there are no changes (#193).

  * Remember recently selected templates (#183).

  * Fix crash when running rehex for the first time on some systems (#194).



=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 debhelper (>= 9)
Build-Depends-Arch:
 libbotan-2-dev,
 libcapstone-dev,
 libgtk-3-dev,
 libjansson-dev,
 liblua5.3-dev,
 libtemplate-perl,
 libunistring-dev,
 libwxgtk3.2-dev,
 lua-busted,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.2-headers,
 zip,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libbotan-2-19,
 libcapstone5,
 libjansson4,
 liblua5.3-0,
 libunistring5,
 libwxgtk3.2-1t64,
 zlib1g
Description: Reverse Engineers' Hex Editor
